VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4410
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5910
   LinkTopic       =   "Form1"
   ScaleHeight     =   4410
   ScaleWidth      =   5910
   StartUpPosition =   3  'Windows Default
   Begin VB.Label lblB 
      Alignment       =   1  'Right Justify
      BorderStyle     =   1  'Fixed Single
      Caption         =   "255"
      Height          =   285
      Left            =   1080
      TabIndex        =   3
      Top             =   3000
      Width           =   375
   End
   Begin VB.Label lblG 
      Alignment       =   1  'Right Justify
      BorderStyle     =   1  'Fixed Single
      Caption         =   "255"
      Height          =   285
      Left            =   600
      TabIndex        =   2
      Top             =   3000
      Width           =   375
   End
   Begin VB.Label lblR 
      Alignment       =   1  'Right Justify
      BorderStyle     =   1  'Fixed Single
      Caption         =   "255"
      Height          =   285
      Left            =   120
      TabIndex        =   1
      Top             =   3000
      Width           =   375
   End
   Begin VB.Label lblColor 
      BorderStyle     =   1  'Fixed Single
      Height          =   375
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   375
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const NUM_ROWS As Integer = 8
Private Const NUM_COLS As Integer = 7
Private Sub InterpolateColumn(ByVal col As Integer, ByVal mid_r As Integer, ByVal mid_g As Integer, ByVal mid_b As Integer)
Dim mid As Integer
Dim row As Integer
Dim r As Single
Dim g As Single
Dim b As Single
Dim dr As Single
Dim dg As Single
Dim db As Single

    ' Lighter colors.
    mid = (NUM_ROWS - 1) \ 2
    dr = (255 - mid_r) / (mid + 1)
    dg = (255 - mid_g) / (mid + 1)
    db = (255 - mid_b) / (mid + 1)
    r = 255
    g = 255
    b = 255
    For row = 0 To mid
        r = r - dr
        g = g - dg
        b = b - db
        lblColor(row * NUM_COLS + col).BackColor = RGB(r, g, b)
    Next row

    ' Darker colors.
    mid = (NUM_ROWS - 1) \ 2
    dr = mid_r / (NUM_ROWS - 1 - mid + 1)
    dg = mid_g / (NUM_ROWS - 1 - mid + 1)
    db = mid_b / (NUM_ROWS - 1 - mid + 1)
    For row = mid + 1 To NUM_ROWS - 1
        r = r - dr
        g = g - dg
        b = b - db
        lblColor(row * NUM_COLS + col).BackColor = RGB(r, g, b)
    Next row
End Sub
Private Sub UnRGB(ByRef color As OLE_COLOR, ByRef r As Byte, ByRef g As Byte, ByRef b As Byte)
    r = color And &HFF&
    g = (color And &HFF00&) \ &H100&
    b = (color And &HFF0000) \ &H10000
End Sub


Private Sub Form_Load()
Const GAP As Single = 30
Dim row As Integer
Dim col As Integer
Dim i As Integer

    ' Make the color sample labels.
    i = 0
    For row = 0 To NUM_ROWS - 1
        For col = 0 To NUM_COLS - 1
            If row > 0 Or col > 0 Then
                Load lblColor(i)
                With lblColor(i)
                    If col = 0 Then
                        .Left = lblColor(0).Left
                        .Top = lblColor(i - NUM_COLS).Top + .Height + GAP
                    Else
                        .Left = lblColor(i - 1).Left + .Width + GAP
                        .Top = lblColor(i - 1).Top
                    End If
                    .Visible = True
                End With
            End If

            i = i + 1
        Next col
    Next row

    ' Color the samples.
    InterpolateColumn 0, 255, 0, 0
    InterpolateColumn 1, 255, 255, 0
    InterpolateColumn 2, 0, 255, 0
    InterpolateColumn 3, 0, 255, 255
    InterpolateColumn 4, 0, 0, 255
    InterpolateColumn 5, 255, 0, 255
    InterpolateColumn 6, 128, 128, 128

    ' Position the color component labels.
    i = (NUM_ROWS - 1) * NUM_COLS
    lblR.Top = lblColor(i).Top + lblColor(i).Height + 4 * GAP
    lblG.Top = lblR.Top
    lblB.Top = lblR.Top

    i = (NUM_ROWS - 1) * NUM_COLS + NUM_COLS - 1
    Me.Width = lblColor(i).Left + lblColor(i).Width + lblColor(0).Left + Me.Width - Me.ScaleWidth
    Me.Height = lblR.Top + lblR.Height + lblColor(0).Top + Me.Height - Me.ScaleHeight
End Sub

Private Sub lblColor_MouseMove(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim r As Byte
Dim g As Byte
Dim b As Byte

    UnRGB lblColor(Index).BackColor, r, g, b
    lblR.Caption = r
    lblG.Caption = g
    lblB.Caption = b
End Sub


